/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_CLIENTE                                                 */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao do Cliente                           */
/*                                                                            */
/* Criao:                                                                   */
/* 02/05/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/* Manutenes TRG :                                                          */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/*   @H:\SISTEMAS\DBA\SQL\ORACLE\TRG_DTULTATU_PRFO.SQL                        */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CLIENTE'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_CLIENTE
  GO

CREATE TRIGGER DTULTATU_CLIENTE
ON CLIENTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CLIENTE', 'CDCLIENTE=' + CDCLIENTE+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CLIENTE
      SET DTULTATUCLIE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE
       ISNULL(CLIENTE.CDCLIENTE,0) = ISNULL(INSERTED.CDCLIENTE,0);



      UPDATE TABEVEND 
      SET DTULTATUTBVE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED,CLIENTE,DELETED
      WHERE ((ISNULL(DELETED.CDFILTABPREC,0) <> ISNULL(INSERTED.CDFILTABPREC,0)) OR
            (ISNULL(DELETED.CDTABEPREC,0)    <> ISNULL(INSERTED.CDTABEPREC,0))) AND
            (TABEVEND.CDFILIAL  = INSERTED.CDFILTABPREC) AND
            (TABEVEND.CDTABEPREC = INSERTED.CDTABEPREC)

      UPDATE TABEPREC 
      SET DTULTATUTBPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED,CLIENTE,DELETED
      WHERE ((ISNULL(DELETED.CDFILTABPREC,0) <> ISNULL(INSERTED.CDFILTABPREC,0)) OR
            (ISNULL(DELETED.CDTABEPREC,0)    <> ISNULL(INSERTED.CDTABEPREC,0))) AND
            (TABEPREC.CDFILIAL  = INSERTED.CDFILTABPREC) AND
            (TABEPREC.CDTABEPREC = INSERTED.CDTABEPREC)

      UPDATE ITEMPRECO
      SET DTULTATUITPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED,CLIENTE,DELETED
      WHERE ((ISNULL(DELETED.CDFILTABPREC,0) <> ISNULL(INSERTED.CDFILTABPREC,0)) OR
            (ISNULL(DELETED.CDTABEPREC,0)    <> ISNULL(INSERTED.CDTABEPREC,0))) AND
            (ITEMPRECO.CDFILIAL   = INSERTED.CDFILTABPREC) AND
            (ITEMPRECO.CDTABEPREC = INSERTED.CDTABEPREC)

      UPDATE ITEMPRECODIA 
      SET DTULTATUITPD = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED,CLIENTE,DELETED
      WHERE ((ISNULL(DELETED.CDFILTABPREC,0) <> ISNULL(INSERTED.CDFILTABPREC,0)) OR
            (ISNULL(DELETED.CDTABEPREC,0)    <> ISNULL(INSERTED.CDTABEPREC,0))) AND
            (ITEMPRECODIA.CDFILIAL   = INSERTED.CDFILTABPREC) AND
            (ITEMPRECODIA.CDTABEPREC = INSERTED.CDTABEPREC)

      UPDATE CLIEWEBSYNC 
      SET DTULTALTCLIE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)),
          CLIEWEBSYNC.IDATUALIZADO = 'N'
      FROM INSERTED,CLIENTE,DELETED
      WHERE (ISNULL(DELETED.CDCLIENTE,0) <> ISNULL(INSERTED.CDCLIENTE,0) AND
            (CLIEWEBSYNC.CDCLIENTE   = INSERTED.CDCLIENTE)

   END;
END;
GO

UPDATE CLIENTE SET DTULTATUCLIE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUCLIE IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_CLIENTE' and
            type = 'D')
   ALTER TABLE CLIENTE DROP CONSTRAINT DEFAULT_CLIENTE
GO

ALTER TABLE CLIENTE ADD CONSTRAINT DEFAULT_CLIENTE
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUCLIE
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CLIENTE','5.07.005';
GO

